VERSION 4.00
Begin VB.Form frmConfigure 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Configure"
   ClientHeight    =   3240
   ClientLeft      =   180
   ClientTop       =   5205
   ClientWidth     =   7185
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   Height          =   3645
   Left            =   120
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   14.727
   ScaleMode       =   0  'User
   ScaleWidth      =   30.102
   Top             =   4860
   Width           =   7305
   Begin VB.CommandButton butConfigCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   6000
      TabIndex        =   2
      Top             =   2280
      Width           =   855
   End
   Begin VB.TextBox txtNewValue 
      Height          =   315
      Left            =   960
      TabIndex        =   1
      Text            =   " "
      Top             =   360
      Width           =   855
   End
   Begin VB.CommandButton butConfigOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   6000
      TabIndex        =   0
      Top             =   2760
      Width           =   855
   End
End
Attribute VB_Name = "frmConfigure"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
Const ConNrSails = 13
Const conNoOfIslands = 13

Private Sub butConfigCancel_Click()
'Version date = 97.12.27

Dim i As Integer
If ThisConfig = -1 Then
  ShipLength = OldItemValue(1)
  QDeckLength = OldItemValue(2)
  FocleLength = OldItemValue(3)
  GunDeckHeight = OldItemValue(4)
  QDeckHeight = OldItemValue(5)
  ShipWidth = OldItemValue(6)
  ShipDraught = OldItemValue(7)
  ShipTons = OldItemValue(8)
  MastDistance(1) = OldItemValue(9)
  MastDistance(2) = OldItemValue(10)
  MastDistance(3) = OldItemValue(11)
  MastDistance(4) = OldItemValue(12)
  LowestSailFoot(1) = OldItemValue(13)
  LowestSailFoot(2) = OldItemValue(14)
  LowestSailFoot(3) = OldItemValue(15)
  LowestSailFoot(4) = OldItemValue(16)
  SetFraction(2) = OldItemValue(17)
  SetFraction(3) = OldItemValue(18)
  SetFraction(4) = OldItemValue(19)
  MaxYardAngle(0) = OldItemValue(20)
  MaxYardAngle(1) = OldItemValue(21)
  MaxYardAngle(2) = OldItemValue(22)
  MaxYardAngle(3) = OldItemValue(23)
  RudderArea = OldItemValue(24)
  MaxJibAngle = OldItemValue(25)
  MaxHelmAngle = OldItemValue(26)
  Call frmSurprise.DerivedShipParameters
End If
If ThisConfig = -2 Then
  WaterDragFactor = OldItemValue(1)
  RudderFactor = OldItemValue(2)
  BowFactor = OldItemValue(3)
  MassFactor = OldItemValue(4)
  RotatInertFactor = OldItemValue(5)
  RotatDragFactor = OldItemValue(6)
  HeelAngleFactor = OldItemValue(7)
  HeelInertFactor = OldItemValue(8)
  HeelDragFactor = OldItemValue(9)
  Call frmSurprise.DerivedShipParameters
End If
If ThisConfig = -3 Then
  For i = 1 To 12
    HeadWidth(i) = OldItemValue(i)
    FootWidth(i) = OldItemValue(12 + i)
    SailDepth(i) = OldItemValue(24 + i)
    MaxReefs(i) = OldItemValue(36 + i)
    TheorMaxSpeed(i) = OldItemValue(48 + i)
  Next i
  Call frmSurprise.DerivedSailParameters
End If
If ThisConfig = -4 Then
  For i = 1 To 3
    JibFootWidth(i) = OldItemValue(i)
    JibDepth(i) = OldItemValue(3 + i)
    JibTheorMaxSpeed(i) = OldItemValue(6 + i)
  Next i
  Call frmSurprise.DerivedSailParameters
End If
If ThisConfig = -5 Then
  For i = 1 To conNoOfIslands
    IsleLat(i) = OldItemValue(i)
    IsleLon(i) = OldItemValue(conNoOfIslands + i)
    IsleRadius(i) = OldItemValue(2 * conNoOfIslands + i)
  Next i
  booMapMustBePainted = True: Call frmSurprise.MapView
End If
Unload frmConfigure
ThisConfig = 0
Call frmSurprise.SailPlan
Call frmSurprise.PlanView
Call frmSurprise.SetUpDisplay
booSternViewIsChanged = True
End Sub

Private Sub butConfigOK_Click()
'Version date = 96.10.26

ThisConfig = 0
Unload frmConfigure
Call frmSurprise.SetUpDisplay
booSternViewIsChanged = True
End Sub

Private Sub Form_Load()
'Version date = 97.12.28

Dim i As Integer
Dim ParamName_l(26) As String
Show

Select Case ThisConfig
  Case 1
    frmConfigure.Caption = "Modify Ship Dimensions"
    ThisConfig = -1
    ParamName_l(1) = "Ship length"
    ParamName_l(2) = "Quarterdeck length"
    ParamName_l(3) = "Forecastle length"
    ParamName_l(4) = "Gundeck height"
    ParamName_l(5) = "Quarterdeck height"
    ParamName_l(6) = "Ship width"
    ParamName_l(7) = "Ship draught"
    ParamName_l(8) = "Ship tonnage"
    ParamName_l(9) = "Foremast distance"
    ParamName_l(10) = "Mainmast distance"
    ParamName_l(11) = "Mizzen mast distance"
    ParamName_l(12) = "Jib clew distance"
    ParamName_l(13) = "Forecourse foot height"
    ParamName_l(14) = "Maincourse foot height"
    ParamName_l(15) = "Mizzencourse foot height"
    ParamName_l(16) = "Jib foot height"
    ParamName_l(17) = "Set fraction (1 reef)"
    ParamName_l(18) = "Set fraction (2 reefs)"
    ParamName_l(19) = "Set fraction (3 reefs)"
    ParamName_l(20) = "Max foreyard angle"
    ParamName_l(21) = "Max mainyard angle"
    ParamName_l(22) = "Max crossjack angle"
    ParamName_l(23) = "Max mizzenboom angle"
    ParamName_l(24) = "Rudder area"
    ParamName_l(25) = "Max jib angle"
    ParamName_l(26) = "Max helm angle"
    ItemValue$(1) = Format(ShipLength, "0000")
    ItemValue$(2) = Format(QDeckLength, "0000")
    ItemValue$(3) = Format(FocleLength, "0000")
    ItemValue$(4) = Format(GunDeckHeight, "0000")
    ItemValue$(5) = Format(QDeckHeight, "0000")
    ItemValue$(6) = Format(ShipWidth, "0000")
    ItemValue$(7) = Format(ShipDraught, "0000")
    ItemValue$(8) = Format(ShipTons, "0000")
    ItemValue$(9) = Format(MastDistance(1), "0000;-000")
    ItemValue$(10) = Format(MastDistance(2), "0000;-000")
    ItemValue$(11) = Format(MastDistance(3), "0000;-000")
    ItemValue$(12) = Format(MastDistance(4), "0000;-000")
    ItemValue$(13) = Format(LowestSailFoot(1), "0000")
    ItemValue$(14) = Format(LowestSailFoot(2), "0000")
    ItemValue$(15) = Format(LowestSailFoot(3), "0000")
    ItemValue$(16) = Format(LowestSailFoot(4), "0000")
    ItemValue$(17) = Format(SetFraction(2), "0.00")
    ItemValue$(18) = Format(SetFraction(3), "0.00")
    ItemValue$(19) = Format(SetFraction(4), "0.00")
    ItemValue$(20) = Format(MaxYardAngle(0), "0000")
    ItemValue$(21) = Format(MaxYardAngle(1), "0000")
    ItemValue$(22) = Format(MaxYardAngle(2), "0000")
    ItemValue$(23) = Format(MaxYardAngle(3), "0000")
    ItemValue$(24) = Format(RudderArea, "0000")
    ItemValue$(25) = Format(MaxJibAngle, "0000")
    ItemValue$(26) = Format(MaxHelmAngle, "0000")
    LastConfigItem = 26
    For i = 1 To LastConfigItem
      OldItemValue(i) = ItemValue$(i)
      CurrentX = 3.3 - TextWidth(ItemValue$(i))
      CurrentY = i
      If i > 13 Then
        CurrentX = 15.3 - TextWidth(ItemValue$(i))
        CurrentY = i - 13
      End If
      Print ItemValue$(i);
      CurrentX = 4
      If i > 13 Then
        CurrentX = 16
      End If
      Print ParamName_l(i)
    Next i
    txtNewValue.Top = 0.84: txtNewValue.Left = 1.6: txtNewValue.Width = 2#
  Case 2
    frmConfigure.Caption = "Modify Dynamic Properties"
    ThisConfig = -2
    ParamName_l(1) = "Water Drag Factor"
    ParamName_l(2) = "Rudder factor"
    ParamName_l(3) = "Bow Factor"
    ParamName_l(4) = "Mass Factor"
    ParamName_l(5) = "Rotational Inertia Factor"
    ParamName_l(6) = "Rotational Drag Factor"
    ParamName_l(7) = "Heel Angle Factor"
    ParamName_l(8) = "Heeling Inertia Factor"
    ParamName_l(9) = "Heel Drag Factor"
    ItemValue$(1) = Format(WaterDragFactor, "0000")
    ItemValue$(2) = Format(RudderFactor, "0000")
    ItemValue$(3) = Format(BowFactor, "000000.00000")
    ItemValue$(4) = Format(MassFactor, "000000.00000")
    ItemValue$(5) = Format(RotatInertFactor, "000000.00000")
    ItemValue$(6) = Format(RotatDragFactor, "000000.00000")
    ItemValue$(7) = Format(HeelAngleFactor, "000000.00000")
    ItemValue$(8) = Format(HeelInertFactor, "000000.00000")
    ItemValue$(9) = Format(HeelDragFactor, "000000.00000")
    LastConfigItem = 9
    For i = 1 To LastConfigItem
      OldItemValue(i) = ItemValue$(i)
      CurrentX = 5.4 - TextWidth(ItemValue$(i))
      CurrentY = i
      Print ItemValue$(i);
      CurrentX = 6
      Print ParamName_l(i)
    Next i
    txtNewValue.Top = 0.84: txtNewValue.Left = 3.6: txtNewValue.Width = 2#
  Case 3
    frmConfigure.Caption = "Modify Sail Dimensions and Properties"
    ThisConfig = -3
    For i = 1 To 13
      ParamName_l(i) = SailName$(i)
    Next i
    CurrentY = 0: CurrentX = 8.5: Print "Headwidth";
    CurrentX = 12.45: Print "Footwidth";
    CurrentX = 16.25: Print "Depth";
    CurrentX = 19.85: Print "Reefs";
    CurrentX = 23.55: Print "Max speed"
    For i = 1 To 12
      CurrentX = 1: CurrentY = i: Print ParamName_l(i)
      ItemValue$(i) = Format(HeadWidth(i), "000")
      ItemValue$(12 + i) = Format(FootWidth(i), "000")
      ItemValue$(24 + i) = Format(SailDepth(i), "000")
      ItemValue$(36 + i) = Format(MaxReefs(i), "000")
      ItemValue$(48 + i) = Format(TheorMaxSpeed(i), "000")
    Next i
    For i = 1 To 60
      OldItemValue(i) = ItemValue$(i)
    Next i
    For i = 1 To 12
      CurrentX = 8.5: CurrentY = i
        Print ItemValue$(i);
      CurrentX = 12.45
        Print ItemValue$(12 + i);
      CurrentX = 16.25
        Print ItemValue$(24 + i);
      CurrentX = 19.85
        Print ItemValue$(36 + i);
      CurrentX = 23.55
        Print ItemValue$(48 + i);
    Next i
    txtNewValue.Top = 0.84: txtNewValue.Left = 8.3: txtNewValue.Width = 1.6
    LastConfigItem = 60
  Case 4
    frmConfigure.Caption = "Modify Staysail Dimensions and Properties"
    ThisConfig = -4
    ParamName_l(1) = "Large jib"
    ParamName_l(2) = "Working jib"
    ParamName_l(3) = "Storm jib"
    CurrentY = 0: CurrentX = 8.5: Print "Footwidth";
    CurrentX = 12.45: Print "Depth";
    CurrentX = 16.25: Print "Max speed"
    For i = 1 To 3
      CurrentX = 1: CurrentY = i: Print ParamName_l(i)
      ItemValue$(i) = Format(JibFootWidth(i), "000")
      ItemValue$(3 + i) = Format(JibDepth(i), "000")
      ItemValue$(6 + i) = Format(JibTheorMaxSpeed(i), "000")
    Next i
    For i = 1 To 9
      OldItemValue(i) = ItemValue$(i)
    Next i
    For i = 1 To 3
      CurrentX = 8.5: CurrentY = i
        Print ItemValue$(i);
      CurrentX = 12.45
        Print ItemValue$(3 + i);
      CurrentX = 16.25
        Print ItemValue$(6 + i)
    Next i
    txtNewValue.Top = 0.84: txtNewValue.Left = 8.3: txtNewValue.Width = 1.6
    LastConfigItem = 9
  Case 5
    frmConfigure.Caption = "Modify Island Positions and Dimensions"
    ThisConfig = -5
    For i = 1 To conNoOfIslands
      ParamName_l(i) = "Island no." & Str$(i)
    Next i
    CurrentY = 0: CurrentX = 8.8: Print "N. Lat.";
    CurrentX = 12.2: Print "E. Long.";
    CurrentX = 16.7: Print "Radius"
    For i = 1 To conNoOfIslands
      CurrentX = 1: CurrentY = i: Print ParamName_l(i)
      ItemValue$(i) = Format(IsleLat(i), "000.0000;-00.0000")
      ItemValue$(1 * conNoOfIslands + i) = Format(IsleLon(i), "000.0000;-00.0000")
      ItemValue$(2 * conNoOfIslands + i) = Format(IsleRadius(i), "000.0000")
    Next i
    For i = 1 To conNoOfIslands * 3
      OldItemValue(i) = ItemValue$(i)
    Next i
    For i = 1 To conNoOfIslands
      CurrentX = 10.6 - TextWidth(ItemValue$(i)): CurrentY = i
        Print ItemValue$(i);
      CurrentX = 14.7 - TextWidth(ItemValue$(conNoOfIslands + i))
        Print ItemValue$(conNoOfIslands + i);
      CurrentX = 18.7 - TextWidth(ItemValue$(2 * conNoOfIslands + i))
        Print ItemValue$(2 * conNoOfIslands + i);
    Next i
    txtNewValue.Top = 0.84: txtNewValue.Left = 7.7: txtNewValue.Width = 3.2
    LastConfigItem = 39
End Select
ConfigItem = 1
txtNewValue = ItemValue$(1)
txtNewValue.SelStart = 0
txtNewValue.SelLength = Len(ItemValue$(1))
txtNewValue.SetFocus
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Version date = 97.12.28

Dim YMax_l As Integer

YMax_l = 14
If ThisConfig = -2 Then
  YMax_l = 10
End If
If ThisConfig = -4 Then
  YMax_l = 4
End If
If Int(Y) < YMax_l And Int(Y) > 0 Then
  ConfigItem = Int(Y)
  Select Case ThisConfig
    Case -1
      If Int(X) > 11 Then ConfigItem = ConfigItem + 13
    Case -3
      If Int(X) > 11 Then ConfigItem = ConfigItem + 12
      If Int(X) > 15 Then ConfigItem = ConfigItem + 12
      If Int(X) > 19 Then ConfigItem = ConfigItem + 12
      If Int(X) > 23 Then ConfigItem = ConfigItem + 12
    Case -4
      If Int(X) > 11 Then ConfigItem = ConfigItem + 3
      If Int(X) > 15 Then ConfigItem = ConfigItem + 3
    Case -5
      If Int(X) > 11 Then ConfigItem = ConfigItem + 13
      If Int(X) > 15 Then ConfigItem = ConfigItem + 13
  End Select
  Call NewNewValueField
Else
  beep
End If
End Sub

Private Sub txtNewValue_Keydown(KeyCode As Integer, Shift As Integer)
'Version date = 97.12.28

Dim Temp_l As String, Delta_l As Integer

If KeyCode < Asc("0") Or KeyCode > Asc("9") Then
  'control key pressed
  booNewValue = False
  If KeyCode = 13 Or KeyCode = vbKeyDown Or KeyCode = vbKeyUp Or KeyCode = vbKeyHome Then
    CurrentY = txtNewValue.Top + 0.16
    Line (txtNewValue.Left, CurrentY)-(txtNewValue.Left + txtNewValue.Width, CurrentY + 1), BackColor, BF
    CurrentY = txtNewValue.Top + 0.16
    If ThisConfig = -1 Then
      Temp_l = Format(txtNewValue.Text, "0000;-000")
      If ConfigItem > 16 And ConfigItem < 20 Then
        Temp_l = Format(txtNewValue.Text, "0.00")
      End If
      Delta_l = 13
    End If
    If ThisConfig = -2 Then
      If ConfigItem < 3 Then
        Temp_l = Format(txtNewValue.Text, "0000")
      Else
        Temp_l = Format(txtNewValue.Text, "000000.00000")
      End If
      Delta_l = 1
    End If
    If ThisConfig = -3 Then
      Temp_l = Format(txtNewValue.Text, "000")
      Delta_l = 12
    End If
    If ThisConfig = -4 Then
      Temp_l = Format(txtNewValue.Text, "000")
      Delta_l = 3
    End If
    If ThisConfig = -5 Then
      Temp_l = Format(txtNewValue.Text, "000.0000;-00.0000")
      Delta_l = 13
    End If
    If IsNumeric(txtNewValue.Text) Then
      If ItemValue$(ConfigItem) <> Temp_l Then
        booNewValue = True
        ItemValue$(ConfigItem) = Temp_l
      End If
    Else
      Temp_l = ItemValue$(ConfigItem)
      Call frmSurprise.ShowMessage("Must be numeric")
    End If
    CurrentX = txtNewValue.Left + txtNewValue.Width - TextWidth(Temp_l) - 0.2
    Print Temp_l
    Select Case KeyCode
      Case vbKeyDown
        'cursor down
       ConfigItem = ConfigItem + 1
      Case vbKeyUp
        'cursor up
        ConfigItem = ConfigItem - 1
        If ConfigItem > LastConfigItem Then
          ConfigItem = ConfigItem - LastConfigItem
        End If
      Case 13
        'enter
        ConfigItem = ConfigItem + Delta_l
        If ConfigItem > LastConfigItem Then
          ConfigItem = ConfigItem - LastConfigItem
        End If
      Case vbKeyHome
        ConfigItem = ConfigItem - Delta_l
        If ConfigItem < 1 Then
          ConfigItem = LastConfigItem + ConfigItem
        End If
    End Select
    KeyCode = 0
    If ConfigItem > LastConfigItem Then ConfigItem = 1
    If ConfigItem < 1 Then ConfigItem = LastConfigItem
    Call NewNewValueField
  End If
End If
End Sub

Public Sub NewNewValueField()
'Version date = 97.12.27

Dim i

txtNewValue.Top = ConfigItem - 0.16
Select Case ThisConfig
  Case -1
    If ConfigItem > 13 Then
      txtNewValue.Left = 13.5
      txtNewValue.Top = ConfigItem - 13.16
    Else
      txtNewValue.Left = 1.6
    End If
    If booNewValue = True Then
      ShipLength = ItemValue(1)
      QDeckLength = ItemValue(2)
      FocleLength = ItemValue(3)
      GunDeckHeight = ItemValue(4)
      QDeckHeight = ItemValue(5)
      ShipWidth = ItemValue(6)
      ShipDraught = ItemValue(7)
      ShipTons = ItemValue(8)
      MastDistance(1) = ItemValue(9)
      MastDistance(2) = ItemValue(10)
      MastDistance(3) = ItemValue(11)
      MastDistance(4) = ItemValue(12)
      LowestSailFoot(1) = ItemValue(13)
      LowestSailFoot(2) = ItemValue(14)
      LowestSailFoot(3) = ItemValue(15)
      LowestSailFoot(4) = ItemValue(16)
      SetFraction(2) = ItemValue(17)
      SetFraction(3) = ItemValue(18)
      SetFraction(4) = ItemValue(19)
      MaxYardAngle(0) = ItemValue(20)
      MaxYardAngle(1) = ItemValue(21)
      MaxYardAngle(2) = ItemValue(22)
      MaxYardAngle(3) = ItemValue(23)
      RudderArea = ItemValue(24)
      MaxJibAngle = ItemValue(25)
      MaxHelmAngle = ItemValue(26)
      Call frmSurprise.DerivedShipParameters
    End If
  Case -2
    If ConfigItem < 3 Then
      txtNewValue.Left = 3.6: txtNewValue.Width = 2
    Else
      txtNewValue.Left = 0.7: txtNewValue.Width = 4.9
    End If
    WaterDragFactor = ItemValue(1)
    RudderFactor = ItemValue(2)
    BowFactor = ItemValue(3)
    MassFactor = ItemValue(4)
    RotatInertFactor = ItemValue(5)
    RotatDragFactor = ItemValue(6)
    HeelAngleFactor = ItemValue(7)
    HeelInertFactor = ItemValue(8)
    HeelDragFactor = ItemValue(9)
  Case -3
    txtNewValue.Left = 8.2
    If ConfigItem > 12 Then
      txtNewValue.Left = 12.2: txtNewValue.Top = ConfigItem - 12.16
    End If
    If ConfigItem > 24 Then
      txtNewValue.Left = 16: txtNewValue.Top = ConfigItem - 24.16
    End If
    If ConfigItem > 36 Then
      txtNewValue.Left = 19.6: txtNewValue.Top = ConfigItem - 36.16
    End If
    If ConfigItem > 48 Then
      txtNewValue.Left = 23.3: txtNewValue.Top = ConfigItem - 48.16
    End If
    If booNewValue = True Then
      For i = 1 To 12
        HeadWidth(i) = ItemValue$(i)
        FootWidth(i) = ItemValue$(12 + i)
        SailDepth(i) = ItemValue$(24 + i)
        MaxReefs(i) = ItemValue$(36 + i)
        TheorMaxSpeed(i) = ItemValue$(48 + i)
      Next i
      Call frmSurprise.DerivedSailParameters
    End If
  Case -4
    txtNewValue.Left = 8.2
    Select Case ConfigItem
      Case 4, 5, 6
        txtNewValue.Left = 12.2: txtNewValue.Top = ConfigItem - 3.16
      Case 7, 8, 9
        txtNewValue.Left = 16: txtNewValue.Top = ConfigItem - 6.16
      Case 10, 11, 12
        txtNewValue.Left = 19.6: txtNewValue.Top = ConfigItem - 9.16
    End Select
    If booNewValue = True Then
      For i = 1 To 3
        JibFootWidth(i) = ItemValue$(i)
        JibDepth(i) = ItemValue$(3 + i)
        JibTheorMaxSpeed(i) = ItemValue$(6 + i)
      Next i
      Call frmSurprise.DerivedSailParameters
    End If
  Case -5
    txtNewValue.Left = 7.7
    If ConfigItem > 13 Then
      txtNewValue.Left = 11.7: txtNewValue.Top = ConfigItem - 13.16
    End If
    If ConfigItem > 26 Then
      txtNewValue.Left = 15.7: txtNewValue.Top = ConfigItem - 26.16
    End If
    If booNewValue = True Then
      For i = 1 To conNoOfIslands
        IsleLat(i) = ItemValue$(i)
        IsleLon(i) = ItemValue$(conNoOfIslands + i)
        IsleRadius(i) = ItemValue$(2 * conNoOfIslands + i)
      Next i
    End If
End Select
txtNewValue = ItemValue$(ConfigItem)
txtNewValue.SelStart = 0
txtNewValue.SelLength = Len(ItemValue$(ConfigItem))

If ThisConfig = -5 Then
  booMapMustBePainted = True: Call frmSurprise.MapView
Else
  Call frmSurprise.SailPlan
  Call frmSurprise.PlanView
End If
End Sub
